#ifndef HSL_H
#define HSL_H
/****************************************************************************/
/*  Copyright (c) 1995-2000, ADLink Technology Inc.  All rights reserved.   */
/*                                                                          */
/*  File Name   :   HSL.H                                              */
/*  Purpose     :   Header file for HSL Card                           */
/*  Date        :   02/01/2001                                              */
/*  Revision    :   1.10                                                    */
/****************************************************************************/

/****************************************************************************/
/*      Typedef  Definitions                                                */
/****************************************************************************/
typedef unsigned char   U8;
typedef short           I16;
typedef unsigned short  U16;
typedef long            I32;
typedef unsigned long   U32;
typedef float           F32;
typedef double          F64;
typedef char            Boolean;

#define     	MAX_PCI_CARDS 	4

#define     	TRUE            1
#define     	FALSE          	0

#define    	HIGH          	1
#define     	LOW  		0

#define         IC8259_1        0x20
#define         IC8259_2        0xA0
#define         EOI             0x20

#define 	Card_0	      	0
#define       	Card_1  	1
#define		Card_2		2
#define		Card_3		3

#define 	TMR_INT		0
#define 	CHK2_INT	1
#define		SCANR_INT	2
#define		SCANW_INT	3
#define		DREQ_INT	4

#define 	LINT1		1
#define		LINT2		2

#define 	ENABLE		1
#define		DISABLE		0

typedef struct
{
	U32 baseAddr[MAX_PCI_CARDS];
        U32 timer_baseAddr[MAX_PCI_CARDS];
        U16 lcrAddr[MAX_PCI_CARDS];
	U16 irqNo   [MAX_PCI_CARDS];
        void   interrupt (far *old_isr[MAX_PCI_CARDS]) (void);
} PCI_INFO;

extern void interrupt _HSL_isr0(void);
extern void interrupt _HSL_isr1(void);
extern void interrupt _HSL_isr2(void);
extern void interrupt _HSL_isr3(void);

/****************************************************************************/
/*      Function  Declerations                                              */
/****************************************************************************/

extern U16  _HSL_Initial(U16 *existCards, PCI_INFO *info);
extern void _HSL_Software_Reset(U16 cardNo);
//extern void _HSL_Get_IRQ_Status (U16 cardNo, U16 *ch1 );
//extern word interrupt_status( word plx_lcr_ba,word n );

extern void _HSL_Get_IRQ_Channel(U16 cardNo, U16 *irq_no );
extern void _HSL_Get_Base_Addr(U16 cardNo, U32 *base_addr );
//extern void _HSL_Set_INT_Enable(U16 cardNo, U16 intFlag );
extern void _HSL_Close(U16 cardNo);

//
extern U16 _HSL_Start(U16 cardNo, U16 connect_index, U16 sat_num);
extern U16 _HSL_Stop(U16 cardNo, U16 connect_index);
extern U16 _HSL_DIO_In(U16 cardNo, U16 sat_id, U16* in_data);
extern U16 _HSL_DI16DO16(U16 cardNo, U16 sat_id, U16* in_data, U16 out_data);
extern U16 _HSL_DIO_REG(U16 cardNo, U16 connect_index, U16 sat_id, U16* reg_data); //add by Robert
extern U16 _HSL_DIO_Out(U16 cardNo, U16 sat_id, U16 out_data);
extern U16 _HSL_DIO_Status(U16 cardNo, U16 sat_id, U8* sts_data);
extern U16 _HSL_DIO_Count(U16 cardNo, U16 sat_id, U16 count_id, U16* in_data);
extern U16 _HSL_Set_Watch_Time(U16 cardNo, U16 sleeptime1, U16 sleeptime2);
extern U16 _HSL_Get_Watch_Time(U16 cardNo, U16* sleeptime1, U16* sleeptime2);
extern void _HSL_timer_test(U16 cardNo); //add by robert

// The following functions are added by Sigma Wu
extern void _HSL_Timer_Set(U16 cardNo, U16 c1, U16 c2);
extern void _HSL_PCI_INT_Setting(U16 cardNo, U16 intCh, U16 intFlag );
extern void _HSL_PCI_INT_Status (U16 cardNo, U16 *ch1, U16 *ch2);
extern void _HSL_Local_INT_Setting(U16 CardNo, U16 intCh, U16 set);
extern void _HSL_Local_INT_Status(U16 CardNo, U16 intCh, U16 *sts);
extern void _HSL_Local_INT_Clear(U16 CardNo, U16 intCh);
#endif
