
/****************************************************************************/
/*  Copyright (c) 1999-2004, ADLink Technology Inc.  All rights reserved.   */
/*                                                                          */
/*  File Name   :   HSL_DEMO.C                                              */
/*  Purpose     :   Testing Program for HSL DI16DO16                        */
/*  Date        :   02/01/2001                                              */
/*  Revision    :   1.00                                                    */
/****************************************************************************/

#include <dos.h>
#include <conio.h>
#include <bios.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include "HSL.h"

PCI_INFO info;

void interrupt far _HSL_isr0(void){} 	// Reserved for interrupt service routine

/****************************************************************************/
/*      MAIN for HSL_DEMO.c                                                 */
/****************************************************************************/

void main(void)
{
	int 	count;
	U16     bn=0;
	U16	di_data, do_data;
	U16     slv_addr;

	clrscr();

	_HSL_Initial( &bn,  &info  );   // bn = number of exist PCI-7851 cards
					// info=board infomation
	_HSL_Software_Reset(0);

	printf("==================================================\n" );
	printf("PCI-7851 & HSL DI16DO16 Demo Program v1.00        \n" );
	printf("Base address of PCI-HSL card[%1d]: %lX\n" ,0, info.baseAddr[0] );
	printf("IRQ Channel  of PCI-HSL card[%1d]: %d\n"  ,0, info.irqNo[0]    );
	printf("==================================================\n" );

	_HSL_Start(0, 0, 63); 		//Start all slave modules
	slv_addr = 63;			//Assign address 63 to slave module
	delay(5);
	while(!kbhit())     	        //test loop start
	{
	 do_data = 0xaaaa;
	 _HSL_DI16DO16(0, slv_addr, &di_data, do_data);
	 gotoxy(1,6);
	 printf("Input data = %04XH",di_data);
	 gotoxy(1,7);
	 printf("\r");
	 for(count=15;count>=0;count--)	// show 16 digit inputs
	     printf("%d ", (di_data >> count) & 0x0001);
	 delay(300);
	 do_data = 0x5555;
	 gotoxy(1,6);
	 _HSL_DI16DO16(0, slv_addr, &di_data, do_data);
	 printf("Input data = %04XH",di_data);
	 gotoxy(1,7);
	 printf("\r");
	 for(count=15;count>=0;count--)
	     printf("%d ", (di_data >> count) & 0x0001);
	 delay(300);
	}
	_HSL_Stop(0,0);             	// stop HSL connection
	_HSL_Close(0);                	// release system resource
}

